WATCH(1)

NOME
watch - executa um programa periodicamente, mostrando saída em tela cheia

SINOPSE
watch [opções] comando

DESCRIÇÃO
watch runs command repeatedly, displaying its output and errors (the first screenfull). This allows you to watch the program output change over time. By default, command is run every 2 seconds and watch will run until interrupted.

OPÇÕES

-d, --differences [permanente]
    Realça as diferenças entre as atualizações sucessivas. A opção irá ler o argumento opcional que muda o realce para ser permanente, permitindo ver o que mudou pelo menos uma vez desde a primeira iteração.

-n, --interval segundos
    Specify update interval. The command will not allow quicker than 0.1 second interval, in which the smaller values are converted. Both '.' and ',' work for any locales.

-p, --precise
    Faz o watch tentar executar o comando a cada intervalo segundos. Experimente com ntptime e perceba como os segundos fracionários permanecem (quase) os mesmos, em oposição ao modo normal onde aumentam continuamente.

-t, --no-title
    Desligue o cabeçalho mostrando o intervalo, comando e tempo atual na parte superior da tela, bem como a seguinte linha em branco.

-b, --beep
    Apita se o comando tem uma saída anormal, com código não zero.

-e, --errexit
    Congela atualizações quando houver um erro no comando, e sai após um tecla ser pressionada.

-g, --chgexit
    Sai quando a saída de comando alterar.

-c, --color
    Interpreta cores ANSI e sequências de estilo.

-x, --exec
    Pass command to exec(2) instead of sh -c which reduces the need to use extra quoting to get the desired effect.

-h, --help
    Exibe um texto de ajuda e sai.

-v, --version
    Exibe informação da versão e sai.

STATUS DE SAÍDA

    0   Sucesso.
    1   Várias falhas.
    2   O fork do processo a ser assistido falhou.
    3   Substituição da stdout (saída padrão) do processo filho com pipe lateral de escrita falhou.
    4   Execução do comando falhou.
    5   Encerramento do pipe de escrita do processo filho falhou.
    7   Criação de pipe IPC falhou.
    8   Obtenção de valor de retorno de processo filho com waitpid(2) falhou, ou o comando saiu com um erro.
    outro
        O watch vai propagar o status de saída do comando como status de saída de filho.

NOTAS
POSIX option processing is used (i.e., option processing stops at the first non-option argument). This means that flags after command don't get interpreted by watch itself.

ERROS
Após o redimensionamento do terminal, a tela não será redesenhada corretamente até a próxima atualização agendada. Todos os realces de --differences são perdidas nessa atualização também. Caracteres não imprimíveis são removidos da saída do programa. Use "cat -v" como parte do pipeline de comando se você quiser vê-los. Caracteres de Combinação que devem ser exibidos no caractere na última coluna na tela podem ser exibidos uma coluna antes ou podem não ser exibidos. Caracteres de Combinação nunca contam como diferente no modo --differences. Apenas só caracteres base contam. As linhas em branco diretamente após uma linha que termina na última coluna não são exibidas. O modo --precise ainda não possui tecnologia de distorção temporal avançada para compensar um comando que leva mais de intervalo segundos para executar. watch também pode entrar em um estado no qual ele dispara rapidamente tantas execuções de comando quanto possível para recuperar as execuções anteriores que funcionam por mais tempo que intervalo (por exemplo, netstat levando muito tempo em uma pesquisa de DNS).

EXEMPLOS
Para monitorar por correio, você pode fazer
    watch -n 60 from
Para assistir conteúdo de um diretório mudar, você pode usar
    watch -d ls -l
Se você está interessado apenas em arquivos pertencentes ao usuário fulano, você pode usar
    watch -d 'ls -l | fgrep fulano'
Para ver os efeitos das aspas, tente esses aqui
    watch echo $$
    watch echo '$$'
    watch echo "'"'$$'"'"
Para ver o efeito da manutenção da precisão do tempo, tente adicionar -p a
    watch -n 10 sleep 1
Você pode assistir seu administrador para instalar o kernel mais recente com
    watch uname -r
(Note que não há garantia de que -p funcione entre reinicializações, especialmente em face de ntpdate ou outros mecanismos de mudança de tempo quando da inicialização)